summaryrefslogtreecommitdiff
path: root/test
diff options
context:
space:
mode:
authorJulian Andres Klode <jak@debian.org>2021-10-18 13:37:47 +0000
committerJulian Andres Klode <jak@debian.org>2021-10-18 13:37:47 +0000
commitefa3528de4277a3d5195c5ce875e7ee960726239 (patch)
tree259ded536c8f6359c4c4bf629ba8e310f17f799a /test
parent76bd0ab589f5a577bd6127bf6487fd351de5b32a (diff)
parent1edf8551cef0a7db7fdcdd5d6b06aec2ea7bb70d (diff)
Merge branch 'pu/ifrange' into 'main'
Add AllowRange option to disable HTTP Range usage See merge request apt-team/apt!188
Diffstat (limited to 'test')
-rwxr-xr-xtest/integration/test-http-if-range91
-rw-r--r--test/interactive-helper/aptwebserver.cc2
2 files changed, 92 insertions, 1 deletions
diff --git a/test/integration/test-http-if-range b/test/integration/test-http-if-range
new file mode 100755
index 000000000..462d731cf
--- /dev/null
+++ b/test/integration/test-http-if-range
@@ -0,0 +1,91 @@
+#!/bin/sh
+set -e
+
+TESTDIR="$(readlink -f "$(dirname "$0")")"
+. "$TESTDIR/framework"
+setupenvironment
+configarchitecture 'amd64'
+
+changetowebserver
+
+TESTFILE='aptarchive/testfile'
+HTTPFILE="http://localhost:${APTHTTPPORT}/testfile"
+DOWNFILE='./downloaded/testfile'
+DOWNLOADLOG='rootdir/tmp/testdownloadfile.log'
+
+testdownloadfile() {
+ rm -f "$DOWNLOADLOG"
+ msgtest "Testing download of file with" "$1"
+ if ! downloadfile "$HTTPFILE" "$DOWNFILE" > "$DOWNLOADLOG"; then
+ cat >&2 "$DOWNLOADLOG"
+ msgfail
+ else
+ msgpass
+ fi
+}
+
+nopartialfile() {
+ rm -f "$DOWNFILE"
+}
+validpartialfile() {
+ head -n 5 "$TESTFILE" > "$DOWNFILE"
+ touch -d "$(stat --format '%y' "${TESTFILE}")" "$DOWNFILE"
+}
+badolderpartialfile() {
+ head -n 5 "$TESTFILE" > "$DOWNFILE"
+ touch -d "$(stat --format '%y' "${TESTFILE}") - 1sec" "$DOWNFILE"
+}
+badnewerpartialfile() {
+ head -n 5 "$TESTFILE" > "$DOWNFILE"
+ touch -d 'now + 1hour' "$DOWNFILE"
+}
+fullfile() {
+ cp -a "$TESTFILE" "$DOWNFILE"
+}
+
+cp -a "${TESTDIR}/framework" "$TESTFILE"
+
+testrun() {
+ nopartialfile
+ testdownloadfile "no file $1"
+ testwebserverlaststatuscode "$2" "$DOWNLOADLOG"
+ testsuccess cmp "$TESTFILE" "$DOWNFILE"
+
+ validpartialfile
+ testdownloadfile "good partial file $1"
+ testwebserverlaststatuscode "$3" "$DOWNLOADLOG"
+ testsuccess cmp "$TESTFILE" "$DOWNFILE"
+
+ badolderpartialfile
+ testdownloadfile "bad old partial file $1"
+ testwebserverlaststatuscode "$4" "$DOWNLOADLOG"
+ testsuccess cmp "$TESTFILE" "$DOWNFILE"
+
+ badnewerpartialfile
+ testdownloadfile "bad new partial file $1"
+ testwebserverlaststatuscode "$4" "$DOWNLOADLOG"
+ testsuccess cmp "$TESTFILE" "$DOWNFILE"
+
+ fullfile
+ testdownloadfile "complete file $1"
+ testwebserverlaststatuscode "$5" "$DOWNLOADLOG"
+ testsuccess cmp "$TESTFILE" "$DOWNFILE"
+}
+
+testrun 'defaults' '200' '206' '200' '416'
+
+webserverconfig 'aptwebserver::support::range' 'false'
+testrun 'no ranges' '200' '200' '200' '200'
+webserverconfig 'aptwebserver::support::range' 'true'
+
+webserverconfig 'aptwebserver::support::if-range' 'false'
+# the second 206 is bad, but we are unable to detect this
+testrun 'buggy server' '200' '206' '206' '416'
+echo 'Acquire::http::localhost::AllowRanges "false";' > rootdir/etc/apt/apt.conf.d/noallowranges
+testrun 'range disabled by conf' '200' '200' '200' '200'
+rm rootdir/etc/apt/apt.conf.d/noallowranges
+# detect varnish < 6.4 automatically
+webserverconfig 'aptwebserver::response-header::Via' '1.1 varnish (Varnish/6.1)'
+testrun 'bad varnish' '200' '200' '200' '200'
+webserverconfig 'aptwebserver::response-header::Via' '1.1 varnish (Varnish/6.4)'
+testrun 'good varnish' '200' '206' '206' '416'
diff --git a/test/interactive-helper/aptwebserver.cc b/test/interactive-helper/aptwebserver.cc
index 58ba54f84..d4bac24d1 100644
--- a/test/interactive-helper/aptwebserver.cc
+++ b/test/interactive-helper/aptwebserver.cc
@@ -828,7 +828,7 @@ static void * handleClient(int const client, size_t const id) /*{{{*/
ifrange = LookupTag(*m, "If-Range", "");
bool validrange = (ifrange.empty() == true ||
(RFC1123StrToTime(ifrange, cache) == true &&
- cache <= data.ModificationTime()));
+ cache == data.ModificationTime()));
// FIXME: support multiple byte-ranges (APT clients do not do this)
if (condition.find(',') == std::string::npos)